#include "summa.hh"
#include "tulo.hh"
#include "yksikot.hh"
#include "yksikko.hh"

extern void Dump(elemp res);

extern Yksikot           Yks;
extern Yksikkomuunnokset Ymu;

summa& summa::operator*= (elemp p)
{
	elemap nmap;
	for(elemap::iterator i = elems.begin(); i != elems.end(); ++i)
	{
        tulop tmp = new tulo;
        tmp->insert(p);
        tmp->insert(i->first);
        nmap[&*tmp] += i->second;
	}
	elems = nmap;
	return *this;
}

bool summa::operator== (const Elem &e) const
{
	if(type != e.type)return false;
	const summa &tmp = *(const summa *)&e;
	return lisays == tmp.lisays
	    && elems == tmp.elems;
}
bool summa::operator< (const Elem &e) const
{
	if(type < e.type)return true;
	if(type > e.type)return false;
	const summa &tmp = *(const summa *)&e;
	
	if(lisays < tmp.lisays)return true;
	if(lisays > tmp.lisays)return false;
	
	unsigned b=tmp.size();
	
	if(size() < b)return true;
	if(size() > b)return false;
	
	elemap::const_iterator i, j;
	
	for(i=elems.begin(), j=tmp.elems.begin();
	    i!=elems.end();
	    ++i, ++j)
	{
		if(i->second < j->second)return true;
		if(i->second > j->second)return false;
		if(i->first < j->first)return true;
	}
	return false;
}

void summa::Yksmuu(class Yksikkomuunnokset &)
{
}

elemp summa::Expand()
{
	elemap::iterator i, eka = elems.begin();
retry:
	cout << "Optimizing: "; Dump(this);
	if(elems.size() == 1 && lisays == 0)
	{
		elemap::iterator j = elems.begin();
		if(j->second == 1)
		{
			return j->first->Expand();
		}
	}
	for(i=eka; i!=elems.end(); ++i)
	{
		if(i->second == 0)
		{
			eka = i;
			elems.erase(i);
			goto retry;
		}
		if(i->first->type == '+')
		{
			summap j = (summa *)&*i->first;
			elems.erase(i);
			lisays += j->lisays;
			for(elemap::iterator k = j->elems.begin();
			                     k!= j->elems.end();
			                     ++k)
			{
			    elems[k->first] += k->second * i->second;
			}
			/* Jumping out of this scope uninitializes j,
			 * and causes the pointer to be deallocated.
			 */
			eka = elems.begin();
			goto retry;
		}
		if(i->first->type == '*')
		{
			for(;;)
			{
    			tulo &tt = *(tulo *)&*i->first;
    			
    			Yksikkomuunnokset::const_iterator ymi, ybe;
    			
    			int befo = 0;
    			
    			for(ymi = Ymu.begin(); ymi != Ymu.end(); ++ymi)
    			{
    				tulo &t = *ymi->first;
    				
    				tulo::elemap::iterator a, b;
    				
    				int totsize = 0;
    				int found   = 0;
    				
    				cout << "Analyzing "; Dump(&*ymi->first);
    				
    				for(a = t.elems.begin(); a != t.elems.end(); ++a)
    				{
    					tulo::potype pot = a->second;
    					int abspot = pot<0 ? -pot : pot;
    					totsize += abspot;
    					
    					b = tt.elems.find(new yksikko(a->first->type));
    					if(b != tt.elems.end())
    					{
    						cout << "- Found from src: want pot=" << pot << ", bsecond=" << b->second << endl;
    						if((pot > 0 && b->second > 0)
    						|| (pot < 0 && b->second < 0))
    						{
    							tulo::potype ab = b->second - pot;
    							if(pot < 0)ab = -ab;
    							cout << "- Which is good, ab=" << ab << ", abspot=" << abspot << "!\n";
    							if(ab > 0)
    								found += abspot;
    							else
    								found += int(abspot + ab);
    						}
    					}
    				}
    				
    				cout << "- totsize = " << totsize << ", found=" << found << endl;
    				
    				if(found > befo && found >= (totsize-1)/2)
    				{
    					cout << "- -> new record\n";
    					befo = found;
    					ybe = ymi;
    				}
    			}
 				if(befo)
 				{
    				tulo &t = *ybe->first;
    				tulo::elemap::iterator a;
    				for(a = t.elems.begin(); a != t.elems.end(); ++a)
    				{
    					cout << "'" << a->first->type << "' cumulating with " << -a->second << endl;
    					tt.elems[a->first] += -a->second;
    				}
    				cout << "Done, I think\n" << flush;
    				
    				merknum newke = i->second.value() * ybe->second;
    				elemp newelem = i->first->Expand();
    				
    				elems.erase(i);
    				
    				if(newke != 0)
    					elems[&*newelem] = newke;
    					
    				eka = elems.begin();
    				
    				goto retry;
 				}
    			cout << "No change\n" << flush;
    			break;
			}
		}
	}
	elemap nmap;
	for(i=elems.begin(); i!=elems.end(); ++i)
		nmap[i->first->Expand()] += i->second;
	if(elems != nmap)
	{
		cout << "Was: "; Dump(this);
		elems = nmap;
		eka = elems.begin();
		cout << "Now: "; Dump(this);
		goto retry;
	}
	return new summa(*this);
}
